using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.NegativeAdjustment.Cqrs;

public class UpdateNegativeAdjustmentItemRequest
{
    public string? Id { get; set; }
    public string? ProductId { get; set; }
    public string? WarehouseId { get; set; }
    public double? Movement { get; set; }
}

public record UpdateNegativeAdjustmentItemCommand(UpdateNegativeAdjustmentItemRequest Data) : IRequest<bool>;

public class UpdateNegativeAdjustmentItemHandler : IRequestHandler<UpdateNegativeAdjustmentItemCommand, bool>
{
    private readonly AppDbContext _context;
    public UpdateNegativeAdjustmentItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(UpdateNegativeAdjustmentItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        entity.ProductId = request.Data.ProductId;
        entity.WarehouseId = request.Data.WarehouseId;
        entity.Movement = Math.Abs(request.Data.Movement ?? 0);

        _context.CalculateInvenTrans(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}